package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.*;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<E> {

    private E[] arr;

    public ArrayUtility(E[] inputArray) { arr = inputArray; }

    public Integer countDuplicatesInMerge(E[] arrayToMerge, E valueToEvaluate) {
        int count = 0;
        Object[] combined = Stream.concat(Arrays.stream(arr), Arrays.stream(arrayToMerge)).toArray();
        for(Object elements : combined) {
            if(valueToEvaluate.equals(elements)){
                count++;
            }
        }
        return count;
    }

    public E getMostCommonFromMerge(E[] arrayToMerge) {
        int count = 0;
        Object[] combined = Stream.concat(Arrays.stream(arr), Arrays.stream(arrayToMerge)).toArray();
        List<E> mergedArray = new ArrayList<>((Collection<? extends E>) Arrays.asList(combined));
        E mostCommon = mergedArray.stream()
                .collect(Collectors.groupingBy(Function.identity(), Collectors.counting()))
                .entrySet().stream().max(Comparator.comparing(Map.Entry::getValue))
                .map(Map.Entry::getKey).orElse(null);
        return mostCommon;
    }


}
